---
layout: post
title: 使用树莓派安装Windows的尝试
tags: [树莓派, Windows]
---

  树莓派能不能作为迷你主机使用呢？<!--more-->    

# 起因
  前段时间，家里人送给了我一个树莓派4B-8GiB内存版，因为手头用着MacBook Pro，看到这个比我之前用的树莓派3B好了不少的东西，就开始想它能不能和用着一样是ARM架构的Mac Mini M2那样使用，当然想给树莓派安装黑苹果那就是天方夜谭了，毕竟macOS里用到的很多东西也不完全只是ARM，想想也知道既然是苹果自己研发的芯片，里面肯定是有一些比如专有的指令集什么的，树莓派应该算是公版的ARM吧？肯定有些指令是没有的……不过我还是愿意仿个macOS试试看，我在网上看好像[TwisterOS](https://twisteros.com)仿macOS的效果最好，而且它是基于树莓派官方系统开发的，所以应该也没啥兼容性的问题，另外它其他的主题比如仿Windows的做的也不错，但仿Windows还不如给它装一个真正的Windows，毕竟网上是有能够给树莓派安装Windows ARM版的办法的。   

# 给树莓派安装Windows
  最开始我想给树莓派安装Windows的时候手头没有Windows的电脑，但是给树莓派安装Windows所用的软件[Windows on R](https://worproject.com)貌似用到了Windows上的一些东西。不过他们提供了一种可以先给卡里安装WinPE然后再安装系统的办法，最开始我是先尝试的那种方案，我可以先用一张安装了树莓派官方系统启动树莓派，然后用[WoR-flasher](https://github.com/Botspot/wor-flasher)给另外一张卡安装WinPE以及系统镜像。操作很简单，照着README做就行了，不过不知道是为什么，尝试了好几次，每次安装到一半就卡住然后报错安装失败，然后连WinPE都进不去了……   
  我怀疑是通过这种方式安装可能有什么问题，而且当时安装到时候卡是32GiB大小的，虽然官网上说32GiB是足够的，不过也许还是有什么问题？所以后来我重新买了一张64GiB的卡片，并且用Windows去运行Windows on Raspberry imager给卡里安装了Windows 11，不过很奇怪的是还是运行不了……换了好几个系统镜像都不行，后来才发现原来是我自作多情每次启动的时候都把频率调成2.2GHz所以不能启动，默认的1.5GHz或者调高到2.0GHz都没有问题😥，因为这个问题尝试了好多次……   

# 在树莓派上的Windows体验
  安装好之后就可以尝试验证树莓派的生产力了，不过结果让我很失望……首先是我用的TF卡是UHS-1，写速度貌似是10MiB/s？读速度商家宣传是130MiB/s不过实际上我也不太清楚，随机读写估计就更慢了……这样的速度加载东西实在是有够慢……另外目前[在树莓派上使用的Windows驱动](https://github.com/worproject/RPi-Windows-Drivers)里并没有无线网卡和核显的驱动，所以体验也很差，移动窗口之类的操作CPU都占用了不少，我本来还想着考虑能不能比Macbook开虚拟机效果好一些，不过目前来看这个结果应该是只差不好吧……虽然价格上树莓派和Mac Mini M2差了4倍，不过体验这么差的话估计当生产力是没机会了。   

# Linux的生产力对比
  相比之下用树莓派官方的系统感觉要流畅不少，毕竟官方系统的所有驱动都是正常工作的，应该也能使用硬件解码，只是有些桌面版的程序没有，比如MS Office，还有像7-Zip、WinSCP、XShell之类的软件 ~~（其实macOS也不行🤣）~~ ……用Wine怎么样呢？其实我觉得应该好不到哪里，毕竟大多数Windows的程序都是x86_64指令集，Wine想要运行这些软件照样得靠QEMU翻译，只不过可能调用的一些Windows的API可以原生执行而已，除了这些之外，我还试了试用Chromium播放Bilibili的视频，结果也令人大失所望，360p的视频都不能流畅播放，更别说1080p了（当然也不排除是因为Bilibili的视频用了硬件解码器不能解码的编码方式），虽然相比树莓派3B来说确实至少可以流畅浏览网页了，但是连视频都不能流畅播放那看来想当生产力还很远呢。   

# 感想
  果然树莓派还是没有办法当作普通的电脑来用啊，更不用说生产力了，同样的价格至少还能组个能打游戏的电脑。尽管性能比树莓派3B好不少，但毕竟用的还是很低级的芯片，也许它就应该当作物联网的开发板来使用吧，但很奇怪的是如果是这样，树莓派3B就足够了吧，何必开发树莓派4B以及带键盘的树莓派400呢？还有就是树莓派CM4，他们不会真以为自己的芯片速度很快吧🤣？