---
layout: post
title: rpi4-openfyde的使用体验
tags: [树莓派, openfyde]
---

  什么样的系统用户体验更好呢？<!--more-->    

# 起因
  最近玩树莓派感觉有点玩腻了，毕竟我不是搞硬件的人，树莓派的GPIO接口对我来说毫无意义，当作PC或者服务器的话性能又太差了，兼容性也不太行（这么看来新出的树莓派5一样对我来说毫无意义，和4B一样都是垃圾）。但是毕竟那个东西也挺贵的，闲置也不太好，因此我想在上面装上适合普通人使用的系统，然后送给家里的人使用。   

# 系统的选择
  首先服务器版的系统肯定不需要考虑了，谁会用一个满是命令行的系统啊，在我看来普通人使用的系统只能在Windows, MacOS, Android, ChromeOS里面选了，任何GNU/Linux发行版的桌面版在我看来都不太适合普通人使用，[Windows之前已经试过了](/2023/05/22/rpi-win.html)，可以说基本上没法用，就是纯粹的垃圾。MacOS显然还没有什么方案可以安装（至于仿MacOS的TwisterOS对于普通人来说使用难度也很大，安装软件都是难事），Android虽然也不是不能用但是作为桌面端系统效果还是不太行，所以我觉得可能也就只有ChromeOS可以考虑一用了。   
  不过官方的ChromeOS要支持的设备才能刷，树莓派显然不在其中，要么就刷ChromiumOS，但是那个要登谷歌账号，在国内使用也不太好。幸好国内有一家对ChromeOS做了本地化的公司，开发了FydeOS，我看了一下如果想在树莓派上安装，就只能安装FydeOS for You，但那个是收费的，每年要120CNY，太贵了，我肯定是不会考虑的。还好，还有一个替代品，那就是openFyde，两个系统我也不太清楚有什么区别，可能是云服务有所不同吧？对于树莓派来说，安装[rpi4-openfyde](https://github.com/openFyde/overlay-rpi4-openfyde)就可以了，另外想要安装的话最好选文件名中包含“archero”的那个，才能使用Android子系统。   

# 安装与使用体验
  第一次安装的时候我是直接把镜像用Raspberry Pi Imager刷进去的，我以为它和其他的树莓派系统一样刷进去之后再配置其他东西，结果并不是，那个镜像是个安装包，想要用的话需要先格式化TF卡，然后找一个U盘把系统刷进去，然后把U盘和TF卡都插入树莓派才能安装，就和安装ESXi一样。   
  安装之后拔掉U盘重启就可以创建用户使用了，首先作为浏览器为基础的系统，我平时用浏览器可能也就是看看Bilibili吧，之前我使用树莓派官方系统的浏览器看Bilibili效果非常差，看看装了openFyde的效果怎么样？结果令人失望，效果还是一样的差，主要应该还是没有硬件解码的问题吧……树莓派4B的GPU好像只支持硬件解码H264，而树莓派5更是卧龙凤雏，只支持H265，真是有够逆天。这么说来FydeOS for You可是要每年120CNY呢，这个水平的性能他们有自己测过吗？就这样也能收费吗？至于其他不涉及视频的网页倒是还算流畅，不过毕竟GPU很垃圾，有一些特殊情况还是会卡。   
  除了浏览器之外，可能用的比较多的就是Android子系统了吧，要是想轻度办公的话应该需要一个Office，用浏览器的Office也不太好，所以先安装个WPS Office试试看，这个从Fyde的应用商店里就能直接安装，还挺方便的。不过安装好之后效果感觉不太行，首先这个Android子系统居然不支持滚轮，复制粘贴都要像手机那样长按，而且很多时候比如新建文档，它会开两个窗口，原来新建文档的窗口不会关掉……这可不像是能让人用的样子啊……而且整体使用也比浏览器卡，使用起来并不顺畅。另外输入法也不是默认开启的，要在设置里设置，体验也不太行。   
  我试了一下那个应用商店，上面的应用要么就是网页链接，要么就是Android程序，要么就是浏览器插件，Android程序从我用了WPS Office来看不怎么抱有希望了，放网页链接的我感觉有点无语😓，其他系统的浏览器都能把网页当作应用，这个系统反倒是直接当超链接跳过去了……至于浏览器插件，那个只要是能安装浏览器就都能用吧，没啥特别的。   
  虽然普通人可能用不上，这个系统还有一个Linux子系统，具体是什么Linux我没细看，不过好像是使用容器启动的。我试了一下效果还行，只是不知道为什么不能使用全部内存，我使用的是8GiB的树莓派，但是分配给Linux的只有6GiB，存储也是分配的，默认10GiB。明明都是Linux系统为什么ChromeOS要限制子系统的资源呢？   
# 总结
  总的用下来，树莓派4B的性能可能真的就只能看看网页了，连视频都不能流畅播放，安装Android应用效果也很差，不过有时候限制多并不是一件坏事，毕竟对普通人来说如果这个性能让人不要抱有更多的希望，反倒是提高了用户体验呢。虽然如果是用比如Ubuntu之类的系统能做的事情应该更多，但很多情况不是普通人应该关心的事情，尤其这个芯片还是ARM指令集的，即使某些应用提供了Linux版也不一定能在树莓派上安装，尤其这个安装很多时候也不是双击就能搞定的，openFyde至少能做到真想安装Android应用的时候双击还是能安装的，卡虽卡了点，但是一般情况不会出现让普通人看了会看不懂的情况，已经算很不错了。   
  因此，我觉得如果让普通人使用树莓派，安装openFyde是最好的选择了。